import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Base64;
import java.nio.charset.Charset;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.MessageDigest;


class TestAPIRequest{
	public static String HASH_ALGO = "HmacSHA256";
	@SuppressWarnings("unchecked")
	public static void main(String[] args){
		String token = "BYU4Xhbm7N534eFUgOTGLJFj+FfhsG5GgRmwn/gKRFs";
		String new_username = "Ashish Singh Bisht";
		String new_password = "svn8tt3?xWaaa1";
		Map<String,Object> varMap = new HashMap<String,Object>();
		varMap.put("secret", "nSZj5oSGiTrVd/6DnI0e8DOVGmd25DbTaxPwKbksBPw");
		varMap.put("host", "rest.luxsci.com");
		varMap.put("debug", "1");
		varMap.put("user", "admin@apidev.trial6.luxsci.net");
		//For Account type "we don't need password
		varMap.put("pass", "svn8tt3?xWaaa1");
		
		System.out.println("Authenticating:");
			
		//call auth function to get auth token		
		varMap.put("token", token);	
		String auth = null;
		Integer code = null;
		JSONObject jsonObj = null;
		ArrayList<JSONObject> jsonObjList = null;
		Map<String,Object> apiResultMap = auth_Request(varMap);
		if(apiResultMap != null){
			code = (Integer)apiResultMap.get("code");
			jsonObjList = (ArrayList<JSONObject>)apiResultMap.get("data");
		}
		
		if(jsonObjList != null){
			for (int i = 0; i < jsonObjList.size(); i++) {
				jsonObj = jsonObjList.get(i);
				if(jsonObj.get("auth") != null){
					auth = (String)jsonObj.get("auth");
					break;
				}
			}
		}
		
		System.out.println("\nResp Code : " + code + " , Data : " + jsonObjList);		
		if(auth == null) return;

		//Call API request function to get profile details		
		varMap.put("auth", auth);
		varMap.put("method", "GET");
		varMap.put("path", "/perl/api/v2/user/"+ (String)varMap.get("user") +"/profile");
		apiResultMap = api_Request(varMap);
		
		if(apiResultMap != null){
			code = (Integer)apiResultMap.get("code");
			jsonObjList = (ArrayList<JSONObject>)apiResultMap.get("data");
		}
			

		System.out.println("\nResp Code : " + code + " , Data : " + jsonObjList);
		
		Map<String,String> tempMap = null;
		
		//Call API request function to set/change profile name
		varMap.put("auth", auth);
		varMap.put("method", "PUT");
		varMap.put("path", "/perl/api/v2/user/"+ (String)varMap.get("user") +"/profile");
		tempMap = new HashMap<String, String>();
		tempMap.put("contact", new_username);
		varMap.put("data", tempMap);
		apiResultMap = api_Request(varMap);

		if(apiResultMap != null){
			code = (Integer)apiResultMap.get("code");
			jsonObjList = (ArrayList<JSONObject>)apiResultMap.get("data");
		}

		System.out.println("\nResp Code : " + code + " , Data : " + jsonObjList);
		
		//Call API request function to change user password
		varMap.put("auth", auth);
		varMap.put("method", "PUT");
		varMap.put("path", "/perl/api/v2/user/"+ (String)varMap.get("user") +"/password");
		tempMap = new HashMap<String, String>();
		tempMap.put("password", new_password);
		varMap.put("data", tempMap);
										
		apiResultMap = api_Request(varMap);

		if(apiResultMap != null){
			code = (Integer)apiResultMap.get("code");
			jsonObjList = (ArrayList<JSONObject>)apiResultMap.get("data");
		}		
		System.out.println("\nResp Code : " + code + " , Data : " + jsonObjList);
	}	
		

		//Function definition to get auth token		
		@SuppressWarnings("unchecked")
		public static Map<String,Object> auth_Request(Map<String, Object> varMap){		
			String path = "/perl/api/v2/auth";														

																						
			String url = "https://" + (String)varMap.get("host") + path;				
			String method = "POST";														

			long date =  System.currentTimeMillis()/1000;
			JSONObject jsonMap = new JSONObject();										


			String user  = (String) varMap.get("user");
			String pass  = (String) varMap.get("pass");
			String token = (String) varMap.get("token");
			String secret = (String) varMap.get("secret");
			
			if(user!=null){																
																						
				jsonMap.put("token", token);											
				jsonMap.put("date", date);												
				jsonMap.put("user", user);												
				jsonMap.put("pass", pass);												
				jsonMap.put("signature", hmacDigest((token + "\n" + date + "\n" + user + "\n" + pass + "\n"), secret,HASH_ALGO));
			}
			else {
																						
				jsonMap.put("token", (String)varMap.get("token"));						
				jsonMap.put("date", date);												
				jsonMap.put("signature", hmacDigest((token + "\n" + date + "\n"), secret,HASH_ALGO));				
			}			
			return callAPI(jsonMap, method, url, (String) varMap.get("debug"),null);					
		}				

		//Function definition to create api request
		
		@SuppressWarnings({ "unchecked", "rawtypes" })
		public static Map<String, Object> api_Request(Map<String, Object> varMap){
			String auth = (String) varMap.get("auth");
			String method = ((String) varMap.get("method"))!=null?(String) varMap.get("method"):"GET";
			String path = ((String) varMap.get("path"))!=null?(String) varMap.get("path"):"/perl/api/v2";
			
			String queryStr = "&";
			Map<String, String> dataMap = null;
			dataMap = (Map<String,String>) varMap.get("data");
			
			String jsonStr = null;										
			JSONObject jsonMap = new JSONObject();
			StringBuffer hmac = new StringBuffer();						
			String key, value;	
			
			if("PUT".equals(method) || "POST".equals(method)){
				if(dataMap != null){									
					for(Map.Entry item:dataMap.entrySet()){									
						key = item.getKey().toString();
						value = item.getValue().toString();
						jsonMap.put(key, value);										
					}																		
					jsonStr = JSONObject.toJSONString(dataMap);
					try {						
						jsonStr = jsonStr.trim();						
						MessageDigest digest = MessageDigest.getInstance("SHA-256");
						byte[] inputBytes = jsonStr.getBytes();// get bytes array from message
						byte[] sa = digest.digest(inputBytes);
						// convert hash bytes to string (usually in hexadecimal form)						
						for (int i = 0; i < sa.length; i++) {
						 hmac.append(Integer.toString( (sa[i] & 0xff) + 0x100, 16).substring(1) );
						}
					} catch (NoSuchAlgorithmException exception) {
						exception.printStackTrace();
					}					
				}									
			}
			else {														
				if(dataMap != null){					
					for(Map.Entry item:dataMap.entrySet()){
						try {
							key = URLEncoder.encode(item.getKey().toString(), Charset.forName("UTF-8").displayName());
							value = URLEncoder.encode(item.getValue().toString(), Charset.forName("UTF-8").displayName());
							queryStr += key + "=" + value + "&";
						} catch (UnsupportedEncodingException e) {
							e.printStackTrace();
						}																											
					}																						
				}																											
			}																												
			String url = "https://" + (String)varMap.get("host") + "/" + path + ((queryStr.length()>1)?("?"+queryStr):"");	
			String toSign = auth + "\n" + method + "\n" + path + "\n" + "" + "\n";
			toSign += hmac + "\n";
			String sign = hmacDigest(toSign, (String)varMap.get("secret"),HASH_ALGO);
			String cookie = "signature=" + auth + ":" + sign;			
			return callAPI(jsonMap, method, url, (String) varMap.get("debug"), cookie);
		}
		
		public static Map<String,Object> callAPI(JSONObject jsonMap, String method, String url, String debug, String cookie){			
			URL urlObj = null;
			HttpURLConnection con = null;
			Integer code = 0;
			String output = "";
			Map<String,Object> returnMap = new HashMap<String,Object>();					
			ArrayList<JSONObject> listOfObjects = new ArrayList<JSONObject>();
			try {
				urlObj = new URL(url);
				con = (HttpURLConnection) urlObj.openConnection();
			
				con.setRequestMethod(method);
				con.setRequestProperty("User-Agent", "LuxSci APIv2 Java Client");
				con.setRequestProperty("Content-Type", "application/json");
				con.setRequestProperty("Accept", "*/*");
				
				if(cookie != null)
					con.setRequestProperty("Cookie",cookie);				
				if("POST".equals(method) || "PUT".equals(method)){
					String postJsonData = JSONObject.toJSONString(jsonMap);					  
					  // Send post request
					  con.setDoOutput(true);
					  DataOutputStream wr = new DataOutputStream(con.getOutputStream());
					  wr.writeBytes(postJsonData);
					  wr.flush();
					  wr.close();
				}
				
				code = con.getResponseCode();
				
				if (!(code == 201 || code == 200)) {
					throw new Exception("API Invocation Failed : HTTP error code : " + code);
				}
				
				// Reading response from input Stream
				BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
				StringBuffer response = new StringBuffer();
				 
				while ((output = in.readLine()) != null) {
					response.append(output);
				}
				in.close();
				 
				// Getting result from response
				output = response.toString();
				JSONParser parser = new JSONParser();
				Object obj =  parser.parse(output);
				if(obj instanceof JSONObject) {
					listOfObjects.add((JSONObject) obj);
				}
				else if(obj instanceof JSONArray) {
					for(Object jsonObj: (JSONArray)obj) {
						if(jsonObj instanceof JSONObject) {
							listOfObjects.add((JSONObject) jsonObj);
						}
						else
							throw new Exception("Unable to parse one of the Object "+jsonObj.getClass());
					}
				}
				else
					throw new Exception("Unable to parse this Object "+obj.getClass());
			}
			catch (MalformedURLException e1) {
				e1.printStackTrace();
			} catch(ProtocolException e){
				e.printStackTrace();
			} catch(IOException e){
				e.printStackTrace();
			} catch(Exception e){
				e.printStackTrace();
			}			
			returnMap.put("code", code);  
			returnMap.put("data", listOfObjects);
			return returnMap;		
			
		}
		
		private static String getCrypted(String data) {
			return getCrypted(data, null);
		}
		
		private static String getCrypted(String data, String key) {
			String cryptedData = "";
			try {
				String combinedData;
				
				if(key!=null)
					combinedData = data + key;
				else
					combinedData = data;
			
				cryptedData = Base64.getEncoder().encodeToString(combinedData.getBytes());					
			} catch (Exception e) {
				e.printStackTrace();
			}
			return cryptedData;
		}

		public static String hmacDigest(String msg, String keyString, String algo) {
			String digest = null;
			try {
			  SecretKeySpec key = new SecretKeySpec((keyString).getBytes("UTF-8"), algo);
			  Mac mac = Mac.getInstance(algo);
			  mac.init(key);

			  byte[] bytes = mac.doFinal(msg.getBytes("ASCII"));

			  StringBuffer hash = new StringBuffer();
			  for (int i = 0; i < bytes.length; i++) {
				String hex = Integer.toHexString(0xFF & bytes[i]);
				if (hex.length() == 1) {
				  hash.append('0');
				}
				hash.append(hex);
			  }
			  digest = hash.toString();
			} catch (UnsupportedEncodingException e) {
			} catch (InvalidKeyException e) {
			} catch (NoSuchAlgorithmException e) {
			}
			return digest;
		}
	}